﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using WSUniversalLib;

namespace UnitTestProject1
{
    [TestClass]
    public class UnitTest1
    {
        #region Простые тесты
        /// <summary>
        /// Проверка возвращаемого значения метода на соотвествие эталонному №1
        /// </summary>
        [TestMethod]
        public void CheakOnEqualEthalonNumber_1()
        {
            Assert.AreEqual(114147, Calculation.GetQuantityForProduct(3, 1, 15, 20, 45));
        }

        /// <summary>
        /// Проверка возвращаемого значения метода на соотвествие эталонному №2
        /// </summary>
        [TestMethod]
        public void CheakOnEqualEthalonNumber_2()
        {
            Assert.AreEqual(101464, Calculation.GetQuantityForProduct(3, 1, 15, 20, 40));
        }

        /// <summary>
        /// Проверка возвращаемого значения метода на соотвествие эталонному №3
        /// </summary>
        [TestMethod]
        public void CheakOnEqualEthalonNumber_3()
        {
            Assert.AreEqual(88781, Calculation.GetQuantityForProduct(3, 1, 15, 20, 35));
        }

        /// <summary>
        /// Проверка возвращаемого значения метода на соотвествие эталонному №4
        /// </summary>
        [TestMethod]
        public void CheakOnEqualEthalonNumber_4()
        {
            Assert.AreEqual(75962, Calculation.GetQuantityForProduct(3, 2, 15, 20, 30));
        }

        /// <summary>
        /// Проверка возвращаемого значения метода на соотвествие эталонному №5
        /// </summary>
        [TestMethod]
        public void CheakOnEqualEthalonNumber_5()
        {
            Assert.AreEqual(14868, Calculation.GetQuantityForProduct(1, 2, 15, 20, 45));
        }

        /// <summary>
        /// Проверка возвращаемого значения метода на соотвествие эталонному №6
        /// </summary>
        [TestMethod]
        public void CheakOnEqualEthalonNumber_6()
        {
            Assert.AreEqual(33791, Calculation.GetQuantityForProduct(2, 2, 15, 20, 45));
        }

        /// <summary>
        /// Проверка возвращаемого функцией значение на неравенство нулю
        /// </summary>
        [TestMethod]
        public void CheakOnNotNullResult()
        {
            Assert.IsNotNull(Calculation.GetQuantityForProduct(3, 1, 15, 20, 45));
        }

        /// <summary>
        /// Проверка возвращаемого функцией значение на соответсвие int типу
        /// </summary>
        [TestMethod]
        public void CheakOnIsInstanceOfTypeInt()
        {
            Assert.IsInstanceOfType(Calculation.GetQuantityForProduct(3, 1, 15, 20, 45), typeof(int));
        }

        /// <summary>
        /// Проверка на возврат функцией -1 при неправильном типе продукта
        /// </summary>
        [TestMethod]
        public void CheakOnIsTrueEqualEthalonNumber_1()
        {
            Assert.IsTrue(Calculation.GetQuantityForProduct(4, 1, 15, 20, 45) == -1);
        }

        /// <summary>
        /// Проверка на возврат функцией -1 при неправильном типе материала
        /// </summary>
        [TestMethod]
        public void CheakOnIsTrueEqualEthalonNumber_2()
        {
            Assert.IsTrue(Calculation.GetQuantityForProduct(3, 3, 15, 20, 40) == -1);
        }
        #endregion

        #region Сложные тесты

        /// <summary>
        /// Проверка исключения при количестве меньше 0
        /// </summary>
        [TestMethod]
        public void CheakOnArgumentExceptionWhenCountSmallerThen0()
        {
            Assert.ThrowsException<ArgumentException>(() => Calculation.GetQuantityForProduct(3, 3, -1, 20, 40));
        }

        /// <summary>
        /// Проверка исключения при ширине меньше 0
        /// </summary>
        [TestMethod]
        public void CheakOnArgumentExceptionWhenWidthSmallerThen0()
        {
            Assert.ThrowsException<ArgumentException>(() => Calculation.GetQuantityForProduct(3, 3, 2, -4, 40));
        }

        /// <summary>
        /// Проверка исключения при длинне меньше 0
        /// </summary>
        [TestMethod]
        public void CheakOnArgumentExceptionWhenLenghSmallerThen0()
        {
            Assert.ThrowsException<ArgumentException>(() => Calculation.GetQuantityForProduct(3, 3, 2, 20, -40));
        }

        #endregion
    }
}
